unit Wpprtab9;

interface

{$IFDEF WIN32}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, WpTxtDef, WpWinCtr, WpRtfPa, Grids, 
  Spin;    
{$ELSE}
uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, WpTxtDef, WpWinCtr, WpRtfPa, Grids;
{$ENDIF}

type
  TKBTableSelect = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Panel2: TPanel;
    ScrollBox1: TScrollBox;
    StringGrid1: TStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    PaintBox1: TPaintBox;
    WidthCmb: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    ColCmb: TComboBox;
    NoBtn: TCheckBox;
    GroupBox1: TGroupBox;
    Label6: TLabel;
    RueckBtn: TSpeedButton;
    VorBtn: TSpeedButton;
    Label5: TLabel;
    Label7: TLabel;
    double: TCheckBox;
    Dotted: TCheckBox;
    Bevel1: TBevel;
    BreiteEdit: TEdit;
    GesamtEdit: TEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure NoBtnClick(Sender: TObject);
    procedure ColCmbDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ColCmbClick(Sender: TObject);
    procedure WidthCmbDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure WidthCmbClick(Sender: TObject);
    procedure StringGrid1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure VorBtnClick(Sender: TObject);
    procedure RueckBtnClick(Sender: TObject);
    procedure BreiteEditChange(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure GesamtEditExit(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    FButton        : Boolean;
    Farbe,Thickness: Byte;
    Procedure CheckButtons;
    Procedure CheckRechts;
  public
    EditBox   : TWPCustomRtfEdit;
    RtfText   : TWPRtfTextPaint;
    xrow,xcol : Integer;
    Aprp      : array[1..20] of TParProps;
    Procedure SetTable(Txt: TWPRtfTextPaint);
  end;

  var KbTableSelect: TKbTableSelect;

implementation

{ Uses UToolDll;  }
{$R *.DFM}

Procedure TKBTableSelect.CheckButtons;
var Summe,i: Integer;
begin
  SpeedButton2.Enabled:= xCol > 1;
  RueckBtn.Enabled:= StringGrid1.Col > 0;
  VorBtn.Enabled:= StringGrid1.Col < StringGrid1.ColCount-1;
  Summe:= 0;
  For i:= 0 to StringGrid1.ColCount - 1 do begin
    Summe:= Summe + StringGrid1.ColWidths[i];
  end;
  GesamtEdit.Text := IntToStr(Summe);
end;

procedure TKBTableSelect.SpeedButton2Click(Sender: TObject);
var par : PTparagraph;
    r,h,CLeft,c,yStart: Integer;
    Border: TBorder;
    spacebefore, spacebetween : Longint;
    Linie: Byte;
    OhneFarbe  : Boolean;
    Typ: TBorderType;
    LastLine: PTLine;
    LastPar : PTParagraph;
begin
  Typ:= [];
  if NoBtn.Checked then begin
    OhneFarbe := True;
  end
  else begin
    OhneFarbe:= False;
    Include(typ,blBox);
  end;
  Linie:= Thickness;
  if double.Checked then include(typ,blDouble);
  if dotted.Checked then include(typ,blDot);
  if RTFText.active_paragraph<>nil then begin
    par:= RtfText.active_Paragraph;
    LastLine:= RtfText.Active_Line;
    LastPar:= Par;
    if not(paprIsTable in par^.prop) then begin
      EditBox.CreateTable(xRow,xCol,NIL,True);
      EditBox.Refresh;
    end
    else begin
      while (paprIsLeftPar in par^.prop)
      or (paprIsRightPar in Par^.prop) do begin
        if par^.Prev = Nil then break;
        if (not(paprIsLeftPar in Par^.Prev^.Prop))
        and (Not(PaprIsRightPar in Par^.Prev^.Prop)) then break;
        par:= par^.prev;
      end;
    end;
    c:= 1;
    cLeft:= 0;
    if Par^.Line <> NIL then begin
      yStart:= Par^.Line^.y_Start;
      h:= par^.Line^.Height;
    end
    else begin
      yStart:= 0;
      h:= 10;
    end;
    Border:= par^.border;
    spacebefore  := par^.spacebefore;
    spacebetween := par^.spacebetween;
    R:= 1;
    Repeat
      C:= 1;
      CLeft:= 0;
      Repeat
        if par <> NIL then begin
          par^.cWidthPC:= Round(StringGrid1.ColWidths[C-1]*(255/624));
          par^.CLeftPC  := CLeft;
          par^.line^.y_start:= ystart;
          par^.Border.LineType:= [];
          if OhneFarbe = False then begin
            par^.border:= Border;
            par^.Border.LineType:= Typ;
            include(par^.border.LineType,blFinish);
            include(Par^.border.LineType,blEnabled);
            par^.Border.Color := Farbe;
            par^.Border.ThickNess:= Linie;
          end;
          par^.spacebefore  := spacebefore;
          par^.spacebetween := spacebetween;
          if not(paprIsLeftPar in Par^.Prop) then begin
     	    if (xCol = 1) or (C < xCol) then include(par^.prop,paprIsLeftPar);
          end
          else if (C >= XCol) and (xcol > 1) then exClude(par^.Prop,paprIsLeftPar);
          if not(PaprIsRightPar in Par^.Prop) then begin
            if (C > 1) or (xCol = 1) then Include(par^.Prop,paprIsRightPar);
          end
          else if (C = 1) and (xCol > 1) then ExClude(par^.Prop,paprIsRightPar);
          inc(CLeft,par^.CWidthPC);
          if (par^.next=nil) then begin
            RtfText.newParagraph(par,20);
            Editbox.Refresh;
          end;
          if Par^.Next <> NIL then begin
            if (not(paprIsTable in Par^.Next^.Prop))
            and (not((C = xCol) and (R = xRow))) then begin
              RtfText.NewParagraph(par,20);
              include(par^.prop,paprIsTable);
            end
            else par := par^.next;
          end
          else break;
          inc(C);
        end;
      Until (C > xCol) or (par = NIL);
      Inc(R);
      inc(ystart,h);
    Until (R > xRow) or (par = NIL);
    if Par = NIL then ShowMessage('PAR = NIL')
    else begin
      RtfText.NewParagraph(par,20);
      RtfText.active_Paragraph:= LastPar;
      RtfText.active_line := LastLine;
      RtfText.Cursor_Pos:= 0;
    end;
    {dann berflssige TabellenZellen lschen}
    {if par <> NIL then begin
      While paprIsTable in par^.Prop do begin
        exclude(par^.prop,paprisleftpar);
        exclude(par^.prop,paprisrightpar);
        exclude(par^.prop,paprIsTable);
        par^.Border.Linetype:= [];
        include(par^.state,pastmustreformat);
        if Par^.Next <> NIL then par:=par^.next
        else Break;
      end;
    end;}
    ModalResult:= mrOk;
  end;
end;

procedure TKBTableSelect.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TKBTableSelect.FormCreate(Sender: TObject);
var i: Integer;
begin
  FillChar(Aprp[1],Sizeof(TParProps)*20,0);
  For i:= 1 to 20 do begin
    StringGrid1.Cells[i-1,0]:= IntToStr(i);
  end;
  for i:=0 to NumPaletteEntries do ColCmb.Items.Add(IntToStr(i));
  for i:=1 to 5 do WidthCmb.Items.Add(IntToStr(i));
end;

Procedure TKBTableSelect.SetTable(Txt: TWPRtfTextPaint);
var par : PTparagraph;
    RowZaehlen: Boolean;
    Summe,i,w: Integer;
    typ : TborderType;
begin
  RTFText:= Txt;
  xCol:= 0;
  xRow:= 1;
  Farbe:= 0;
  ThickNess:= 0;
  if RTFText.active_paragraph<>nil then begin
    if (paprIsTable in RTFText.active_paragraph^.prop) then begin
      par:= RtfText.active_Paragraph;
      xCol:= 0;
      xRow:= 0;
      while (paprIsLeftPar in par^.prop)
      or (paprIsRightPar in Par^.prop) do begin
        if par^.Prev = Nil then break;
        if (not(paprIsLeftPar in Par^.Prev^.Prop))
        and (Not(PaprIsRightPar in Par^.Prev^.Prop)) then break;
        par:= par^.prev;
      end;
      RowZaehlen:= False;
      if blEnabled in par^.Border.Linetype then begin
        Farbe:= Par^.Border.Color;
        Thickness:= Par^.Border.Thickness;
        double.Checked:= (blDouble in Par^.Border.LineType);
        dotted.Checked:= (blDot in Par^.Border.LineType);
      end
      else NoBtn.Checked:= True;
      while (paprIsRightPar in Par^.Prop)
      or (paprIsLeftPar in par^.prop) do begin
        if RowZaehlen = False then begin
          if xCol < 21 then begin
            inc(xCol);
            ApRp[xCol].cWidth:= par^.cWidthPC;
          end;
        end;
        if not(paprIsLeftPar in Par^.Prop) then begin
          RowZaehlen:= True;
          xRow:= xRow + 1;
        end;
        if par^.next=nil then break;
        par := par^.next;
      end;
      if xRow = 0 then xRow:= 1;
      if xCol = 0 then xCol:= 1;
      Edit1.Text := IntToStr(xRow);
      Edit2.Text := IntToStr(xCol);
    end;
  end;
  if xCol = 0 then begin
    xCol:= 2;
    StringGrid1.DefaultColWidth:= (624 div 2);
    Edit2.Text := '2';
  end
  else StringGrid1.DefaultColWidth:= (624 div xCol);
  if xRow = 0 then xRow:= 1;
  StringGrid1.ColCount:= xCol;
  StringGrid1.RowCount:= xRow + 1;
  StringGrid1.FixedRows:= 1;
  w := RtfText.Canvas.TextHeight('A');
  For i:= 0 to xCol-1 do begin
    if APRP[i+1].cWidth > 0 then StringGrid1.ColWidths[i]:= Round((APRP[i+1].cWidth) * (624/255)) + 1;
  end;
  BreiteEdit.Text := IntToStr(StringGrid1.ColWidths[0]);
  CheckButtons;
  i := Farbe and 15;
  ColCmb.ItemIndex:= i;
  with WidthCmb do
    if Items.IndexOf(IntToStr(Thickness))=-1 then ItemIndex:=0
    else ItemIndex:=Items.Indexof(IntToStr(Thickness));
end;

procedure TKBTableSelect.Edit1Exit(Sender: TObject);
var Txt  : String;
    Code : Integer;
begin
  Txt:= Edit1.Text;
  Val(Txt,xCol,Code);
  if xCol < 1 then xCol:= 1;
  StringGrid1.ColCount:= xCol;
  CheckButtons;
end;

procedure TKBTableSelect.Edit2Change(Sender: TObject);
begin
  StringGrid1.ColCount:= StrToInt(Edit2.Text);
  xCol:= StrToInt(Edit2.Text);
  StringGrid1.DefaultColWidth:= (624 div xCol);
  BreiteEdit.Text := IntToStr(StringGrid1.ColWidths[StringGrid1.Col]);
  CheckButtons;
end;

procedure TKBTableSelect.Edit1Change(Sender: TObject);
begin
  StringGrid1.RowCount:= StrToInt(Edit1.Text) + 1;
  xRow:= StrToInt(Edit1.Text);
end;

procedure TKBTableSelect.PaintBox1Paint(Sender: TObject);
begin
  if (Farbe and 15)>0 then
    with RtfText.Header.FPaletteEntries[(Farbe and 15)] do
    Paintbox1.Canvas.Pen.Color:=TColor(RGB(peRed, peGreen, peBlue))
  else Paintbox1.Canvas.Pen.Color:=clBlack;
  with Paintbox1.Canvas do begin
    Pen.Width:= Thickness;
    MoveTo(1,8); LineTo(100,8);
  end;
end;

procedure TKBTableSelect.NoBtnClick(Sender: TObject);
begin
  Paintbox1.Invalidate;
end;

procedure TKBTableSelect.ColCmbDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  with (Control as TComboBox).Canvas do
  begin
    Brush.color := (Control as TComboBox).Color;
    FillRect(Rect);
    InflateRect(rect, -1, -1);
    if (index>=0) and (index<=NumPaletteEntries) then
         With RtfText.Header.FPaletteEntries[index] do
           	 Brush.color:=TColor(RGB(peRed, peGreen, peBlue));
    Pen.Color:=clBlack;
    Pen.Style:=psSolid;
    FillRect(Rect);
    Rectangle(Rect.Left, Rect.Top, Rect.Right, Rect.Bottom);
  end;
end;

procedure TKBTableSelect.ColCmbClick(Sender: TObject);
begin
  if ColCmb.ItemIndex >= 0 then Farbe:= ColCmb.ItemIndex;
  Paintbox1.Invalidate;
end;

procedure TKBTableSelect.WidthCmbDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  MidPt:Integer;
  BrkPt:Integer;
begin
  with (Control as TComboBox).Canvas do begin
    MidPt:=(Rect.Top +Rect.Bottom) div 2;
    BrkPt:=(Rect.Left+Rect.Right)div 2;
    MoveTo( 5, MidPt);
    if odSelected in state then Pen.Color:=clBlue
    else Pen.Color:=clBlack;
    Brush.color := (Control as TComboBox).Color;
    FillRect(Rect);
    Pen.Width:=(Index + 2);
    LineTo(BrkPt, MidPt);
    TextOut(BrkPt + 5, Rect.Top, (Control as TComboBox).Items.Strings[Index]+ ' Pt.')
  end;
end;

procedure TKBTableSelect.WidthCmbClick(Sender: TObject);
begin
  if Widthcmb.Itemindex >= 0 then Thickness:= Widthcmb.ItemIndex + 1;
  Paintbox1.Invalidate;
end;

Procedure TKBTableSelect.CheckRechts;
var i,Spalte,Summe: Integer;
begin
  Summe:= 0;
  Spalte:= StringGrid1.Col;
  For i:= 0 to StringGrid1.ColCount - 1 do begin
    Summe:= Summe + StringGrid1.ColWidths[i];
  end;
  if Summe > 624 then begin
    if Spalte < StringGrid1.ColCount-1 then begin
      While (Summe > 624) and (StringGrid1.ColWidths[Spalte+1] > 1) do begin
        if StringGrid1.ColWidths[Spalte+1] > 10 then
        StringGrid1.ColWidths[Spalte+1]:= StringGrid1.ColWidths[Spalte+1]-1
        else StringGrid1.ColWidths[Spalte]:= StringGrid1.ColWidths[Spalte] - 1;
        Dec(Summe);
      end;
    end
    else begin
      While (Summe > 624) and (StringGrid1.ColWidths[Spalte] > 1) do begin
        StringGrid1.ColWidths[Spalte]:= StringGrid1.ColWidths[Spalte]-1;
        Dec(Summe);
      end;
    end;
    BreiteEdit.Text := IntToStr(StringGrid1.ColWidths[Spalte]);
  end;
end;

procedure TKBTableSelect.StringGrid1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var aCol,aRow: Longint;
begin
  StringGrid1.MouseToCell(X-2, Y,aCol,ARow);
  StringGrid1.Col:= aCol;
  Label5.Caption := 'Spalte '+ IntToStr(StringGrid1.Col+1);
  BreiteEdit.Text:= IntToStr(StringGrid1.ColWidths[StringGrid1.Col]);
  CheckRechts;
  CheckButtons;
end;

procedure TKBTableSelect.VorBtnClick(Sender: TObject);
begin
  if StringGrid1.Col < StringGrid1.ColCount-1 then
  StringGrid1.Col:= StringGrid1.Col + 1;
  Label5.Caption:= 'Spalte '+IntToStr(StringGrid1.Col+1);
  BreiteEdit.Text:= IntToStr(StringGrid1.ColWidths[StringGrid1.Col]);
  CheckButtons;
end;

procedure TKBTableSelect.RueckBtnClick(Sender: TObject);
begin
  if StringGrid1.Col > 0 then
  StringGrid1.Col:= StringGrid1.Col - 1;
  Label5.Caption:= 'Spalte '+IntToStr(StringGrid1.Col+1);
  BreiteEdit.Text:= IntToStr(StringGrid1.ColWidths[StringGrid1.Col]);
  CheckButtons;
end;

procedure TKBTableSelect.BreiteEditChange(Sender: TObject);
begin
  StringGrid1.ColWidths[StringGrid1.Col]:= StrToInt(BreiteEdit.Text);
  CheckRechts;
  CheckButtons;
end;

procedure TKBTableSelect.StringGrid1Click(Sender: TObject);
begin
  Label5.Caption:= 'Spalte '+IntToStr(StringGrid1.Col+1);
  BreiteEdit.Text:= IntToStr(StringGrid1.ColWidths[StringGrid1.Col]);
  CheckButtons;
end;

procedure TKBTableSelect.GesamtEditExit(Sender: TObject);
var Gesamt,Summe,i,Spalte: Integer;
begin
  Gesamt:= StrToInt(GesamtEdit.Text);
  Summe:= 0;
  For i:= 0 to StringGrid1.ColCount - 1 do begin
    Summe:= Summe + StringGrid1.ColWidths[i];
  end;
  if Gesamt <> Summe then begin
    For i:= 0 to StringGrid1.ColCount - 1 do begin
      StringGrid1.ColWidths[i]:= Round((StringGrid1.ColWidths[i] / Summe) * Gesamt);
    end;
    Summe:= 0;
    For i:= 0 to StringGrid1.ColCount - 1 do begin
      Summe:= Summe + StringGrid1.ColWidths[i];
    end;
    if Summe > Gesamt then begin
      Spalte:= StringGrid1.Col;
      if Spalte < StringGrid1.ColCount-1 then begin
        While (Summe > Gesamt) and (StringGrid1.ColWidths[Spalte+1] > 1) do begin
          if StringGrid1.ColWidths[Spalte+1] > 10 then
          StringGrid1.ColWidths[Spalte+1]:= StringGrid1.ColWidths[Spalte+1]-1
          else StringGrid1.ColWidths[Spalte]:= StringGrid1.ColWidths[Spalte] - 1;
          Dec(Summe);
        end;
      end
      else begin
        While (Summe > Gesamt) and (StringGrid1.ColWidths[Spalte] > 1) do begin
          StringGrid1.ColWidths[Spalte]:= StringGrid1.ColWidths[Spalte]-1;
          Dec(Summe);
        end;
      end;
    end;
    {BreiteEdit.Value:= StringGrid1.ColWidths[Spalte];}
  end;
  CheckButtons;
end;

procedure TKBTableSelect.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

end.
