unit Unit1;

{$I WPINC.INC}

{$IFNDEF WPQUICK}
--- Please edit WPINC.INC to make QuickReport Support available.
    (You have only to activate the definition of the Symbol WPQUICK
{$ENDIF}


interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, WPTbar, WpWinCtr, WPRich, Wpdbrich, DB,
  DBTables, Grids, DBGrids, StdCtrls,  QRLIST, Unit2, WPPanel, Menus, Buttons;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBWPRichText1: TDBWPRichText;
    DBGrid1: TDBGrid;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Print1: TMenuItem;
    FieldList: TPopupMenu;
    WPToolPanel1: TWPToolPanel;
    WPComboBox1: TWPComboBox;
    WPComboBox2: TWPComboBox;
    WPToolButton1: TWPToolButton;
    WPToolButton2: TWPToolButton;
    WPToolButton3: TWPToolButton;
    WPComboBox3: TWPComboBox;
    WPToolPanel2: TWPToolPanel;
    WPToolButton4: TWPToolButton;
    WPToolButton5: TWPToolButton;
    WPToolButton6: TWPToolButton;
    WPToolButton7: TWPToolButton;
    WPToolButton8: TWPToolButton;
    WPToolButton9: TWPToolButton;
    Previewforforms1: TMenuItem;
    Panel1: TPanel;
    Label1: TLabel;
    MEMOFields1: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure x1Click(Sender: TObject);
    procedure Previewforforms1Click(Sender: TObject);
    procedure MEMOFields1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses Qrlist2;

{$R *.DFM}

procedure TForm1.Open1Click(Sender: TObject);
var
  i : Integer;
  m : TMenuItem;
begin
   Table1.Close;
   DBWPRichText1.DataField := '';

   if OpenDialog1.Execute then
   begin
      Table1.DataBaseName := ExtractFilePath( OpenDialog1.FileName);
      Table1.TableName    := ExtractFileName( OpenDialog1.FileName);
      try
        Table1.Open;
      except
      end;
   end;

   if not Table1.Active then
   begin
       Panel1.Visible := TRUE;
       MEMOFields1.Visible := FALSE;
       exit;
   end;

   while FieldList.Items.Count>0 do
       FieldList.Items.Delete(0);
   DBWPRichText1.Clear;
   i := 0;
   while i<Table1.FieldCount do
   begin
     if Table1.Fields[i] is TMemoField then
     begin
        m := TMenuItem.Create(FieldList);
        m.Caption := Table1.Fields[i].FieldName;
        if DBWPRichText1.DataField = ''
          then  DBWPRichText1.DataField := m.Caption;
        m.OnClick := x1Click;
        FieldList.Items.Add( m );
     end;
     inc(i);
   end;
   Panel1.Visible := FALSE;
   MEMOFields1.Visible := TRUE;
   MEMOFields1.Click;
end;



procedure TForm1.Print1Click(Sender: TObject);
begin
   if not Table1.Active then
   begin
       ShowMessage('Please open a Database which contains MEMO fields');
       exit;
   end;
   Form2.FNumber := 1;
   Form2.Number.Caption := '1';
   Form2.FStop := FALSE;
   Form2.FClose := FALSE;
   Form2.Show;
   QRListTemplate.Table1.Close;
   QRListTemplate.Table1.DataBaseName := Table1.DataBaseName;
   QRListTemplate.Table1.TableName    := Table1.TableName;
   QRListTemplate.Table1.Open;
   QRListTemplate.DBWPRichText1.DataField := DBWPRichText1.DataField;
   QRListTemplate.Table1.First;
   { QRListTemplate.QuickReport.Print; }
   QRListTemplate.QuickReport.Preview; 
end;

procedure TForm1.x1Click(Sender: TObject);
begin
   DBWPRichText1.DataField :=
      (Sender as TMenuItem).Caption;
end;

procedure TForm1.Previewforforms1Click(Sender: TObject);
begin
   if not Table1.Active then
   begin
       ShowMessage('Please open a Database which contains MEMO fields');
       exit;
   end;
   Form2.FNumber := 1;
   Form2.Number.Caption := '1';
   Form2.FStop := FALSE;
   Form2.FClose := FALSE;
   Form2.Show;
   QRForms.Table1.Close;
   QRForms.Table1.DataBaseName := Table1.DataBaseName;
   QRForms.Table1.TableName    := Table1.TableName;
   QRForms.Table1.Open;
   QRForms.WPDBQuickPrint1.DataField := DBWPRichText1.DataField;
   QRForms.Table1.First;
   { QRListTemplate.QuickReport.Print; }
   QRForms.QuickReport.Preview;

end;

procedure TForm1.MEMOFields1Click(Sender: TObject);
var
  p : TPoint;
  l : Longint;
begin
   if not Table1.Active then
   begin
      Panel1.Color := clBlue;
      Panel1.Update;
      l := GetTickCount;
      while GetTickCount<l+100 do ;
      Panel1.Color := clBtnFace;
      exit;
   end;
   p.x := 55;
   p.y := 1;
   WinProcs.ClientToScreen(Handle, p);
   FieldList.Popup(p.x,p.y);
end;

end.
